<template>
  <Modal
    :name="nameModal"
    :adaptive="true"
    :classes="classes"
    :width="widthModal"
    :scrollable="isMobile()"
    height="auto"
    @before-open="$emit('before-open')"
    @opened="$emit('opened')"
    @before-close="$emit('before-close')">
    <header
      :class="{ '_no-header': noHeader, '_gray': grayHeader }"
      class="appModal-header">
      <slot name="header"/>
      <button
        type="button"
        class="appModal-close-button"
        @click="$modal.hide(nameModal)">
        <img
          svg-inline
          src="~/assets/svg/redesign/cross.svg">
      </button>
    </header>

    <div class="appModal-body">
      <slot name="body"/>
    </div>

    <footer class="appModal-footer">
      <slot name="footer"/>
    </footer>
  </Modal>
</template>

<script>
import isMobileMixin from '~/assets/js/mixins/is-mobile';

export default {
  name: 'AppModal',
  mixins: [isMobileMixin],
  props: {
    nameModal: {
      type: String,
      default: '',
    },
    widthModal: {
      type: Number,
      default: 600,
    },
    initClass: {
      type: String,
      default: '',
    },
    noHeader: {
      type: Boolean,
      default: false,
    },
    visible: {
      type: Boolean,
      default: false,
    },
    grayHeader: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    classes() {
      return ['appModal', '-custom-scroll', this.initClass];
    },
  },
  // TODO: Создаем новый модуль store для модалок. Заводим enum для типов этих модалок.
  // TODO: И все необходимые actions/mutations.
  watch: {
    visible(newValue) {
      if (newValue) {
        this.$modal.show(this.nameModal);
      } else {
        this.$modal.hide(this.nameModal);
      }
    },
  },
};
</script>

<style lang="postcss">
  .--modal-open {
    overflow: hidden;
  }

  .v--modal-overlay {
    background-color: var(--bg-wrapper);
    min-height: 100%;

    @media (min-width: 1201px) and (max-width: 1365px) {
      .v--modal-box {
        left: 50% !important;
        transform: translateX(-50%);
      }
    }
  }

  .appModal {
    display: block;
    padding: 0;
    width: 100%;
    max-width: 100vw;
    min-height: 4rem;
    max-height: 100%;
    border-radius: 0.25rem;
    background-color: var(--bg-main);
    box-shadow: 0 2px 8px rgba(0, 0, 0, .33);
    overflow-x: hidden;
    overflow-y: auto;

    &-header {
      position: relative;
      display: flex;
      align-items: center;
      padding: 0 3rem 0 1.625rem;
      width: 100%;
      height: 3.5rem;
      border-bottom: 1px solid var(--border-color-main);

      .heading {
        font-family: var(--font-heading);
        font-size: 1.125rem;
        font-weight: var(--font-weight-medium);
      }

      &._no-header {
        padding: 0;
        height: 0;
        border: none;
      }

      &._gray {
        background-color: var(--bg-dark);
      }
    }

    &-title {
      display: block;
      text-align: center;
      font-weight: var(--font-weight-medium);
    }

    &-close-button {
      position: absolute;
      top: 0;
      right: 0;
      z-index: 10;
      display: block;
      padding: 1.25rem;
      background: none;
      border: none;
      outline: none;
      cursor: pointer;

      > .svg {
        width: 0.625rem;
        height: auto;
        fill: var(--color-on-dark-light);
        transition: fill 0.2s var(--transition-easeOutQuad);
      }

      &:hover, &:focus {
        > .svg {
          fill: var(--fill-main);
        }
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      &-close-button > .svg {
        width: 1.25rem;
      }
    }

    @media screen and (max-width: 980px) {
      left: 0 !important;
      top: 0 !important;
      display: flex;
      flex-direction: column;
      align-items: center;
      margin-left: auto;
      margin-right: auto;
      width: 100%;
      min-width: 20rem;
      max-width: 30rem;
      height: auto;
      border-radius: 0;

      &-header {
        justify-content: center;
        padding-top: 3rem;
        height: auto;
        text-align: center;
        border-bottom: none;

        &._gray {
          background-color: var(--bg-main);
        }

        .heading {
          font-size: 1.375rem;
        }
      }

      &-close-button > .svg {
        width: 1.25rem;
      }

      &-title {
        font-size: 1.375rem;
      }

      &-body {
        display: flex;
        flex-direction: column;
        flex-grow: 1;
        width: 100%;
        height: 100%;
        overflow-y: auto;
        overflow-x: hidden;
      }

      &-footer {
        margin-top: auto;
      }
    }
  }

</style>
